# coding: utf-8

"""
    Authress

    <p> <h2>Introduction</h2> <p>Welcome to the Authress Authorization API. <br>The Authress REST API provides the operations and resources necessary to create records, assign permissions, and verify any user in your platform.</p> <p><ul>   <li>Manage multitenant platforms and create user tenants for SSO connections.</li>   <li>Create records to assign roles and resources to grant access for users.</li>   <li>Check user access control by calling the authorization API at the right time.</li>   <li>Configure service clients to securely access services in your platform.</li> </ul></p> <p>For more in-depth scenarios check out the <a href=\"https://authress.io/knowledge-base\" target=\"_blank\">Authress knowledge base</a>.</p> </p>

    The version of the OpenAPI document: v1
    Contact: support@authress.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
try:
    from pydantic.v1 import BaseModel, Field, StrictStr, validator
except ImportError:
    from pydantic import BaseModel, Field, StrictStr, validator

class ConnectionUserDataConfiguration(BaseModel):
    """
    ConnectionUserDataConfiguration
    """
    location: Optional[StrictStr] = Field(default=None, description="User data residency - The data residency to store the user specific data in. To ensure high performance and reliability, set to **null**, or to store the user's data only in one specific region, set the region here. Specifying the region reduces reliability, durability, and performance at the benefit of controlling the locality. ")
    __properties = ["location"]

    @validator('location')
    def location_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('ZAF', 'HKG', 'IND', 'JPN', 'KOR', 'SGP', 'AUS', 'IDN', 'CAN', 'DEU', 'CHE', 'SWE', 'ITA', 'IRL', 'GBR', 'FRA', 'ISR', 'BHR', 'ARE', 'BRA', 'USA'):
            raise ValueError("must be one of enum values ('ZAF', 'HKG', 'IND', 'JPN', 'KOR', 'SGP', 'AUS', 'IDN', 'CAN', 'DEU', 'CHE', 'SWE', 'ITA', 'IRL', 'GBR', 'FRA', 'ISR', 'BHR', 'ARE', 'BRA', 'USA')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ConnectionUserDataConfiguration:
        """Create an instance of ConnectionUserDataConfiguration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if location (nullable) is None
        # and __fields_set__ contains the field
        if self.location is None and "location" in self.__fields_set__:
            _dict['location'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ConnectionUserDataConfiguration:
        """Create an instance of ConnectionUserDataConfiguration from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ConnectionUserDataConfiguration.parse_obj(obj)

        _obj = ConnectionUserDataConfiguration.parse_obj({
            "location": obj.get("location")
        })
        return _obj


