# coding: utf-8

"""
    Authress

    <p> <h2>Introduction</h2> <p>Welcome to the Authress Authorization API. <br>The Authress REST API provides the operations and resources necessary to create records, assign permissions, and verify any user in your platform.</p> <p><ul>   <li>Manage multitenant platforms and create user tenants for SSO connections.</li>   <li>Create records to assign roles and resources to grant access for users.</li>   <li>Check user access control by calling the authorization API at the right time.</li>   <li>Configure service clients to securely access services in your platform.</li> </ul></p> <p>For more in-depth scenarios check out the <a href=\"https://authress.io/knowledge-base\" target=\"_blank\">Authress knowledge base</a>.</p> </p>

    The version of the OpenAPI document: v1
    Contact: support@authress.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
try:
    from pydantic.v1 import BaseModel, Field, StrictStr, conlist, constr
except ImportError:
    from pydantic import BaseModel, Field, StrictStr, conlist, constr
from authress.models.links import Links

class ExtensionApplication(BaseModel):
    """
    The extension's application configuration. The application contains the necessary information for users to log in to the extension.  # noqa: E501
    """
    application_id: StrictStr = Field(default=..., alias="applicationId", description="The unique ID of the application.")
    redirect_urls: Optional[conlist(constr(strict=True, max_length=1024), max_items=100, min_items=0)] = Field(default=None, alias="redirectUrls")
    links: Optional[Links] = None
    __properties = ["applicationId", "redirectUrls", "links"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ExtensionApplication:
        """Create an instance of ExtensionApplication from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "application_id",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of links
        if self.links:
            _dict['links'] = self.links.to_dict()
        # set to None if redirect_urls (nullable) is None
        # and __fields_set__ contains the field
        if self.redirect_urls is None and "redirect_urls" in self.__fields_set__:
            _dict['redirectUrls'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ExtensionApplication:
        """Create an instance of ExtensionApplication from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ExtensionApplication.parse_obj(obj)

        _obj = ExtensionApplication.parse_obj({
            "application_id": obj.get("applicationId"),
            "redirect_urls": obj.get("redirectUrls"),
            "links": Links.from_dict(obj.get("links")) if obj.get("links") is not None else None
        })
        return _obj


